/*
 * hchclient.c
 * demo tool for hchlib_1.0.h
 */

#include "hchlib.h"
#include <stdlib.h>
#include <fcntl.h>

#define TIMEOUT	 5
#define PORTAR	 "1234"
#define PORTAS	 "1235"
#define MAX  16000

int 
main(int argc, char **argv)
{
	int mode=0, encoding=0, listalen;
	char lista[MAX_DATA], mimetype[25], mime[MAX_MIME], transfer[MAX_TENC];
	int sd, fin, offset = 0, bytes = 0;
  char buffer[MAX];

	switch(argc){
		case 3 :
			if(strcmp(argv[2], "-l") == 0){
   			mode = 2;
				break;
			}
		case 4 :
			if((argc == 4) && (strcmp(argv[2], "-s") == 0)){
				mode = 1;
				break;
			}
		case 5 :
			if(argc == 5){
				if(strcmp(argv[4], "-q") == 0){
					mode = 1;
					encoding = 1;
					break;
				} else if(strcmp(argv[4], "-b") == 0){
					mode = 1;
					encoding = 2;
				  break;
				}
			}
		default:
			printf("Usage: %s server -s/-l [filename] <-q/-b>\n"
						 "server     name of the server (ip or network name)\n"
		         "-s         send file to server\n"
		         "-l         list file on server(require no other args)\n"
		         "[filename] file to send name\n"
						 "-q or -b   to choose encoding, default no encoding\n", argv[0]);
		return 1;
	}

	
	if(mode == 2){
		if((sd = create_hchlib(argv[1], PORTAS, 5)) < 0) return 1;
		get_hchlib(sd, lista, &listalen, transfer, mime);
		printf("List of remote files:\n");
		printf("%s\n", lista);
		return 0;
	}
	
	switch(encoding){
		case 0 :
			strcpy(mimetype, "text/binary; no-encoding");
		  strcpy(transfer, "binary");
			break;
		case 1 :
			strcpy(mimetype, "text/printable");
		  strcpy(transfer, "quoted-printable");
			break;
		case 2 :
			strcpy(mimetype, "application/binary");
		  strcpy(transfer, "base64");
			break;
	}
	
	if(mode == 1){
		if((sd = create_hchlib(argv[1], PORTAR, 5)) < 0) return 1;
		
		if((fin = open(argv[3], O_RDONLY)) == -1){
			printf("file not found\n");
			return 1;
		}
		
		do{
			bytes = read(fin, buffer, sizeof(buffer));

      post_hchlib(sd, buffer, bytes, transfer, mimetype);
			
			offset += bytes;
		} while (bytes == sizeof(buffer));
	
    close(fin);
		
		printf("Send %d bytes of %s\n", offset, argv[3]);

		return 0;
	}
}

