/*
 * hchserverS.c
 * demo tool for hchlib_1.0.h
 */

#include "hchlib.h"
#include <stdlib.h>
#include <dirent.h>

#include <fcntl.h>

#define PERMS 0666
#define BACKLOG 15
#define PORTA	 1235
#define MAX  16000
#define MAX_PATH 256

int listdir(char *, char *);

int 
main(int argc, char **argv)
{
  int buffer_len;	
	unsigned char buffer[MAX];
	char lista[MAX], path[MAX_PATH];
	int sd, csd, i, j, fout, n;
	
	switch(argc){
		case 1 :
			strcpy(path, ".");
		  break;
		case 2 :
			strcpy(path, argv[1]);
			break;
		default:
			printf("Usage: %s <dir_path>\n"
						 "dir_path   set working path (current if omitted)\n", argv[0]);
		return 1;
	}
	
	
	
	if((sd = listen_hchlib(PORTA, BACKLOG)) < 0) return 1;
		
	for(; ;){
    csd = accept_hchlib(sd);
		
		listdir(lista, path);
		i=send_hchlib(csd, lista, sizeof(lista), "7bit", "text/us-ascii"); 
		if(i < 0){
			continue;
		}
  }
  return 0;
}

int listdir(char *megalist, char *path){
	DIR *dir;
	struct dirent *entry;
	char entry_path[MAX_PATH + 1];
	int path_len;
	int num, punt = 0;
	
	strncpy(entry_path, path, sizeof(path));
	path_len = strlen(path);
	
	if(entry_path[path_len-1] != '/'){
		entry_path[path_len] = '/';
		entry_path[path_len+1] = '\0';
	  ++path_len;
	}
	
	dir = opendir(path);
	
	while((entry = readdir(dir)) != NULL){
		strncpy(entry_path + path_len, entry->d_name, sizeof(entry_path) - path_len);
		num = sprintf(megalist + punt, "%-18d %s\n",  entry->d_reclen, entry_path);
		punt = punt + num;
	}
	closedir(dir);
	
	return 0;
}
